/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.attr.AttrType
 *  fire.pb.attr.FightAttrType
 *  fire.pb.main.ConfigManager
 *  fire.pb.main.ModuleInterface
 *  fire.pb.main.ModuleManager
 *  fire.pb.main.ReloadResult
 *  fire.pb.team.PropertiesListener
 *  mkdb.logs.Listener
 *  org.apache.log4j.Logger
 *  xtable.Properties
 */
package fire.pb.effect;

import fire.pb.attr.AttrType;
import fire.pb.attr.FightAttrType;
import fire.pb.effect.IEffect;
import fire.pb.effect.SAttrEffectID2Name;
import fire.pb.main.ConfigManager;
import fire.pb.main.ModuleInterface;
import fire.pb.main.ModuleManager;
import fire.pb.main.ReloadResult;
import fire.pb.team.PropertiesListener;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.atomic.AtomicBoolean;
import mkdb.logs.Listener;
import org.apache.log4j.Logger;
import xtable.Properties;

public class Module
implements ModuleInterface {
    public static AtomicBoolean initOnce;
    public static final Logger logger;
    Map<Integer, Class<? extends IEffect>> id2class;
    private Map<String, Integer> effectName2Ids;
    private Map<Integer, String> effectId2Names;
    private Map<String, Integer> attrName2Ids;
    private Map<Integer, Float> attrId2InitValue;
    private List<Integer> needSendAttrIds;
    public static final int[] clientAttrTypeIds;
    public static final int[] fightAttrTypeIds;
    public static final int[] extfightAttrTypeIds;

    public static Module getInstance() {
        return (Module)ModuleManager.getInstance().getModuleByName("effect");
    }

    public void exit() {
    }

    public static boolean isFightAttr(int attrid) {
        if (attrid <= 0) {
            return false;
        }
        for (int i = 0; i < fightAttrTypeIds.length; ++i) {
            if (fightAttrTypeIds[i] != attrid) continue;
            return true;
        }
        return false;
    }

    public Map<String, Integer> getEffectName2Ids() {
        return this.effectName2Ids;
    }

    public List<Integer> getNeedSendAttrIds() {
        return this.needSendAttrIds;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void init() throws Exception {
        logger.info((Object)"effect模块初始化开始。");
        if (!initOnce.get()) {
            Properties.getTable().addListener((Listener)new PropertiesListener(), new String[]{"value", "hp"});
            Properties.getTable().addListener((Listener)new PropertiesListener(), new String[]{"value", "mp"});
        }
        TreeMap sAttrEffects = ConfigManager.getInstance().getConf(SAttrEffectID2Name.class);
        this.effectId2Names = new HashMap<Integer, String>();
        this.effectName2Ids = new HashMap<String, Integer>();
        this.attrId2InitValue = new HashMap<Integer, Float>();
        this.attrName2Ids = new HashMap<String, Integer>();
        this.needSendAttrIds = new ArrayList<Integer>();
        Map<Integer, String> map = this.effectId2Names;
        synchronized (map) {
            Map<String, Integer> map2 = this.effectName2Ids;
            synchronized (map2) {
                Map<Integer, Float> map3 = this.attrId2InitValue;
                synchronized (map3) {
                    Map<String, Integer> map4 = this.attrName2Ids;
                    synchronized (map4) {
                        this.effectId2Names.clear();
                        this.effectName2Ids.clear();
                        this.attrId2InitValue.clear();
                        this.attrName2Ids.clear();
                        for (SAttrEffectID2Name attreffect : sAttrEffects.values()) {
                            this.effectId2Names.put(attreffect.getId(), attreffect.getAttrname());
                            this.effectId2Names.put(attreffect.getAblEffctId(), attreffect.getAblEffctName());
                            this.effectId2Names.put(attreffect.getPctEffctId(), attreffect.getPctEffctName());
                            this.effectName2Ids.put(attreffect.getAttrname(), attreffect.getId());
                            this.effectName2Ids.put(attreffect.getAblEffctName(), attreffect.getAblEffctId());
                            this.effectName2Ids.put(attreffect.getPctEffctName(), attreffect.getPctEffctId());
                            this.attrId2InitValue.put(attreffect.getId(), Float.valueOf((float)attreffect.getInitValue()));
                            this.attrName2Ids.put(attreffect.getAttrname(), attreffect.getId());
                            if (attreffect.needSendAttr != 1) continue;
                            this.needSendAttrIds.add(attreffect.getId());
                        }
                        this.attrName2Ids.put("curhp_percent", 61);
                        this.attrName2Ids.put("curmp_percent", 91);
                        this.effectName2Ids.put("curhpb", 61);
                        this.effectName2Ids.put("curmpb", 91);
                        this.effectName2Ids.put("curhp", 61);
                        this.effectName2Ids.put("curmp", 91);
                        this.effectName2Ids.put("mineffect", 2990);
                    }
                }
            }
        }
        initOnce.set(true);
        logger.debug((Object)"=====printFinalAttrs begin=====\n");
        for (Map.Entry entry : this.effectName2Ids.entrySet()) {
            logger.debug((Object)("effectid:" + entry.getValue() + "\teffectName:" + (String)entry.getKey() + "\n"));
        }
        logger.debug((Object)"=====printFinalAttrs end=====\n");
        logger.info((Object)"effect模块初始化完成。");
    }

    public ReloadResult reload() throws Exception {
        try {
            this.init();
            return new ReloadResult(true);
        }
        catch (Exception e) {
            logger.error((Object)e);
            return new ReloadResult(false, "effect module reload failed, ");
        }
    }

    public Integer getIdByName(String effectname) {
        String name = effectname.trim();
        return this.effectName2Ids.get(name);
    }

    public String getEffectNameById(int effectId) {
        return this.effectId2Names.get(effectId);
    }

    public static Map<Integer, Float> parseEffects(String effectstrs) throws Exception {
        HashMap<Integer, Float> effectMap = new HashMap<Integer, Float>();
        if (effectstrs != null && !effectstrs.equals("")) {
            String[] effectStr = effectstrs.split(";");
            for (int i = 0; i < effectStr.length; ++i) {
                String[] tmpstrs = effectStr[i].split("=");
                if (tmpstrs.length < 2) continue;
                int effectId = Module.getInstance().getIdByName(tmpstrs[0].trim());
                Float effectValue = Float.valueOf(effectStr[i].substring(tmpstrs[0].length() + 1).trim());
                effectMap.put(effectId, effectValue);
            }
        }
        return effectMap;
    }

    public float getInitValueByAttrId(int attrId) {
        Float inivalue = this.attrId2InitValue.get(attrId);
        if (inivalue == null) {
            return 0.0f;
        }
        return inivalue.floatValue();
    }

    public int getAttrIdByName(String name) {
        Integer id = this.attrName2Ids.get(name);
        if (id == null) {
            return 0;
        }
        return id;
    }

    public float getAblLimit(int attrId) {
        SAttrEffectID2Name effectAttrCfg;
        TreeMap sAttrEffects = ConfigManager.getInstance().getConf(SAttrEffectID2Name.class);
        if (sAttrEffects != null && (effectAttrCfg = (SAttrEffectID2Name)sAttrEffects.get(attrId)) != null) {
            return (float)effectAttrCfg.ablLimit;
        }
        return 0.0f;
    }

    public float getPctLimit(int attrId) {
        SAttrEffectID2Name effectAttrCfg;
        TreeMap sAttrEffects = ConfigManager.getInstance().getConf(SAttrEffectID2Name.class);
        if (sAttrEffects != null && (effectAttrCfg = (SAttrEffectID2Name)sAttrEffects.get(attrId)) != null) {
            return (float)effectAttrCfg.pctLimit;
        }
        return 0.0f;
    }

    public static Map<Integer, Float> getClientAttrs(Map<Integer, Float> attrs) {
        HashMap<Integer, Float> clientAttrs = new HashMap<Integer, Float>();
        for (int attrId : clientAttrTypeIds) {
            Float value = attrs.get(attrId);
            if (value == null) continue;
            clientAttrs.put(attrId, value);
        }
        return clientAttrs;
    }

    static {
        int i;
        initOnce = new AtomicBoolean(false);
        logger = Logger.getLogger((String)"BATTLE");
        Field[] fields = AttrType.class.getFields();
        clientAttrTypeIds = new int[fields.length];
        for (i = 0; i < fields.length; ++i) {
            try {
                Module.clientAttrTypeIds[i] = fields[i].getInt(null);
                continue;
            }
            catch (IllegalArgumentException e) {
                e.printStackTrace();
                continue;
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
        fields = FightAttrType.class.getFields();
        fightAttrTypeIds = new int[fields.length];
        for (i = 0; i < fields.length; ++i) {
            try {
                Module.fightAttrTypeIds[i] = fields[i].getInt(null);
                continue;
            }
            catch (IllegalArgumentException e) {
                e.printStackTrace();
                continue;
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        }
        extfightAttrTypeIds = new int[3];
        Module.extfightAttrTypeIds[0] = 80;
        Module.extfightAttrTypeIds[1] = 100;
        Module.extfightAttrTypeIds[2] = 120;
    }
}

